*! version 0.4.1 2012-09-04 jsl | dcp ocp work | posted
* version 0.4.0 2012-09-03 jsl | cleanup | posted

*! DO: remove o. variables
*! DO: add matrix input

//  get estimates statistics related to model

capture program drop _ordcplot_data_getstats
program _ordcplot_data_getstats, sclass

*TRACE di in blue _new "      = 1 stats  => Entering _ordcplot_data_getstats"

    version 11.2

    args E_Bunstd E_Vunstd E_Bstd E_Brange matrix values debug

    tempname sd rng
    local error = 0

    if "`matrix'"!="matrix" {

        * create variables with stats on RHS variables
        quietly rm3_pesum, dummy
        matrix temp = r(Ssd)'
        matrix temp = temp[2...,1]
        matrix colname temp = _P_EVsd
        svmat temp, names(col)
        label var _P_EVsd "SD of rhs variables"

        matrix temp = r(Sdummy)'
        matrix temp = temp[2...,1]
        matrix colname temp = _P_EVbin
        svmat temp, names(col)
        label var _P_EVbin "Binary indicator of rhs variables"

        matrix temp = r(Smax)' - r(Smin)'
        matrix temp = temp[2...,1]
        matrix colname temp = _P_EVrng
        svmat temp, names(col)
        label var _P_EVrng "Range of rhs variables"

        matrix drop temp

        * information on categories
        local depvar e(depvar)
        rm3_pecats `e(depvar)'
        local catnms  "`r(catnms)'"
        local catvals "`r(catvals)'"
        if "`values'" == "values" local catnms "`r(catvals)'"
        local ncats = r(numcats)
        local catrefnum = e(baseout)
        if (`catrefnum'==0) local catrefnum = 1
        if (`catrefnum'==.) local catrefnum = 1 // for non mlogit

        * model coefficients
        if "`e(cmd)'"=="mlogit" {

            rm3_get_mlogit_bv `E_Bunstd' `E_Vunstd'
            local varnms : colnames(`E_Bunstd') // including _cons
            local varnms = subinstr("`varnms'","_cons","",1)
            local nvars = wordcount("`varnms'")
            matrix `E_Bstd'   = `E_Bunstd' // to hold std betas
            matrix `E_Brange' = `E_Bunstd' // to hold range std betas

            local ivar = 1
            while `ivar' < `nvars'+1 {
                scalar `sd' = _P_EVsd[`ivar']
                scalar `rng' = _P_EVrng[`ivar']
                local icat = 1
                while `icat' < `ncats' {
                    matrix `E_Bstd'[`icat',`ivar'] ///
                        = `E_Bunstd'[`icat',`ivar'] * `sd'
                    matrix `E_Brange'[`icat',`ivar'] ///
                        = `E_Bunstd'[`icat',`ivar'] * `rng'
                    local ++icat
                }
                local ++ivar
            }
        } // mlogit

        else { // not mlogit

            rm3_perhs, noomit
            local varnms `r(rhsnms)'
            local nvars = wordcount("`varnms'")
            matrix `E_Bunstd' = e(b)
            matrix `E_Vunstd' = e(V)
            matrix `E_Bstd' = e(b)*0
            matrix `E_Brange' = e(b)*0

        }

    } // not matrix

//  matrix input

    else {
        *! TODO: add matrix input
    }

//  returns for other programs

    sreturn local varnms "`varnms'"
    sreturn local nvars = `nvars'
    sreturn local catnms "`catnms'"
    sreturn local ncats = `ncats'
        *! DO: verify catvals
    sreturn local catvals "`varnms'"
    sreturn local catrefnum = `catrefnum'
    sreturn local error = `error'

*TRACE di in blue "       = 2 stats  => Leaving _ordcplot_data_getstats"

end
exit

NOTES

if `debug'==99 {
    di "MATRIX global SD of rhs variables"
    mat list temp
}
if `debug'==99 {
    di "MATRIX global BINARY rhs indicator"
    mat list temp
}
if `debug'==99 {
    di "MATRIX global BINARY rhs range"
    mat list temp
}
if `debug'==99 {
    di "MATRIX global depvar `depvar'"
}
if `debug'==99 {
    di "MATRIX global catnms  `catnms'"
    di "MATRIX global catvals `catvals'"
    di "MATRIX global ncats    `ncats'"
    di "MATRIX global catrefnum `catrefnum'"
}
if `debug'==99 {
    di "MATRIX global varnms `varnms'"
    di "MATRIX global varn `varn'"
    di "MATRIX E_Bunstd"
    mat list `E_Bunstd'
    di "MATRIX V_Bunstd"
    mat list `E_Vunstd'
}

HISTORY

* version 0.1.1 2012-08-05 05.29
* version 0.1.2 2012-08-05 06.02 save as variables
* version 0.1.3 2012-08-05 cleanup
