*! version 0.4.1 2012-09-04 jsl | dcp ocp work | posted
* version 0.4.0 2012-09-03 jsl | cleanup | posted

//  create graph commands

program define _ordcplot_graph, sclass

    version 11.2

*TRACE di in blue _new "= 1 graph => Entering _ordcplot_graph"

    args debug OPTaspect OPTbasecat OPTcaption OPTstd ///
        OPTstdlabelspaces OPTdchange OPTdcplot OPTdecimals OPTdepvar ///
        OPTgap OPTgraph OPTlcolor OPTlinegapfac OPTlinepvalue OPTlwidth ///
        OPTmatrix OPTmax OPTmaxvars OPTmcolor OPTmin OPTmodelok OPTmsize ///
        OPTnosign OPTnote OPTntics OPToffsetfac OPToffsetseq OPToffsetlist ///
        OPTordec OPTpacked OPTrefnm OPTsaving OPTtitle OPTsubtitle ///
        OPTvalues OPTvarlabels OPTvarnms OPTxlines

//  x axis information

    * min and max of estimates
    qui sum _P_PVbeta
    local xBmax = r(max)
    local xBmin = r(min)
    if (`OPTmin'==-99999) local OPTmin = `xBmin'
    if (`OPTmax'==99999) local OPTmax = `xBmax'

    * set min max too small, reset
    if `OPTmin'>`xBmin' {
        local temp = string(`xBmin',"%11.4f")
        display "Note: min(`OPTmin') reset to min(`temp')"
        local OPTmin = `xBmin'
    }
    if `OPTmax'<`xBmax' {
        local temp = string(`xBmax',"%11.4f")
        display "Note: max(`OPTmax') reset to max(`temp')"
        local OPTmax = `xBmax'
    }
    char _ordc[plt_xticBmax] `xBmax'
    char _ordc[plt_xticBmin] `xBmin'

    * compute tic values
    local xrange = `OPTmax' - `OPTmin'
    if (`OPTgap'!=0) local spacing = `OPTgap'
    else local spacing = `xrange'/(`OPTntics'-1)

    local xBvalues ""
    local xORvalues ""
    forvalues v = `OPTmin'(`spacing')`OPTmax' {
        local vis = string(`v',"%11.`OPTdecimals'f")
        local xBvalues "`xBvalues' `vis'"
        local oris = exp(`v')
        local oris = string(`oris',"%11.`OPTordec'f")
        local xORvalues `" `xORvalues' `vis' "`oris'" "'
    }
    char _ordc[plt_xticBvalues] `xBvalues'
    char _ordc[plt_xticORvalues] `xORvalues'
    char _ordc[plt_xticmax] `OPTmax'
    char _ordc[plt_xticmin] `OPTmin'
    char _ordc[plt_xticsN] `OPTntics'

//  labels for y axis

    local xstdloc = `OPTmin'
    local varnms `_ordc[plt_rhsNMS]'
    local nvars `_ordc[plt_rhsN]'
    local yticmin = .5
    local yticmax = `nvars' + .5
    char _ordc[plt_yticmax] `yticmax'
    char _ordc[plt_yticmin] `yticmin'

    local yticlab ""
    local ystdlab ""
    local itic = 2
    local ivar = 0
    local nspace = `OPTstdlabelspaces' + $ordc_type_spaces
    local spacer ""
    forvalues i = 1(1)`nspace' {
        local spacer "`spacer' "
    }

    forvalues ticvalue = `yticmax'(-.25)`yticmin' {

        local ++itic

        if `itic'== 4 { // label needed every 4th tic

            local ++ivar
            local varnm : word `ivar' of `varnms'
            local ticlabel "`varnm'"
            if ("`OPTvarlabels'"=="varlabels") & ("`OPTmatrix'"!="matrix") {
                local varlabel : variable label `varnm'
                if ("`varlabel'"!="") local ticlabel "`varlabel'"
            }

            * labels for std type
            local stdopt = substr("`OPTstd'",`ivar',1)
            if ("`stdopt'"=="u") local stdtype "UnStd Coef"
            if ("`stdopt'"=="r") local stdtype "Range Coef"
            if ("`stdopt'"=="s") local stdtype "Std Coef"
            if ("`stdopt'"=="b") local stdtype "0/1"

            if ("`stdopt'"=="u") local stdtype "Unit change"
            if ("`stdopt'"=="r") local stdtype "Range change"
            if ("`stdopt'"=="s") local stdtype "SD change"
            if ("`stdopt'"=="b") local stdtype "From 0 to 1"

            local stdtype "`stdtype'`spacer'"
            local stdyloc = `ticvalue' - .40 // .4 below tic for variable
            local txt `"text(`stdyloc' `xstdloc' "`stdtype'", place(west) "'
            local txt `" `txt' color(black) size(vsmall))"'
            local ystdlab `"`ystdlab' `txt'"'

            local itic = 0
        }
        else {
            local ticlabel " "
        }
        local yticlab `"`yticlab' `ticvalue' "`ticlabel'" "'

    }
    char _ordc[plt_coeftype_text] `ystdlab'
    char _ordc[plt_ytic_labels] `yticlab'

//  y lines

    local ymax = `_ordc[plt_rhsN]' + .5
    local plt_ylinevalues ""
    forvalues y = .5(1)`ymax' { // always start at .5
        local plt_ylinevalues "`plt_ylinevalues' `y'"
    }
    char _ordc[plt_ylinevalues] `"`plt_ylinevalues'"'

//  text boxes for scaled category symbols

    if "`OPTmcolor'"=="" {
        local mcolor "black"
    }
    else {
        local mcolor "`OPTmcolor' `OPTmcolor' `OPTmcolor' `OPTmcolor'"
        local mcolor "`mcolor' `OPTmcolor' `OPTmcolor' `OPTmcolor' `OPTmcolor'"
        local mcolor "`mcolor' `OPTmcolor' `OPTmcolor' `OPTmcolor' `OPTmcolor'"
    }

    qui sum _P_PVvarnum
    local nobs = r(N)
    local txtall ""
    forvalues i = 1(1)`nobs' {

        if "`_ordc[_plot_type_]'"=="dcplot" {
            local xis = _P_PVdc[`i']
        }
        if "`_ordc[_plot_type_]'"=="orplot" {
            local xis = _P_PVbeta[`i']
        }
        local xis = string(`xis',"%11.3f")
        local yis = _P_PVvarnumoffset[`i']
        local yis = string(`yis',"%11.3f")
        local ltris = _P_PVcatstr[`i']
        local ltrnumis =  _P_PVcatnum[`i']
        local ltrcolor : word `ltrnumis' of `mcolor'
        local dcis = _P_PVdc[`i'] // use only if dc option
        local dcneg = _P_PVdcneg[`i']
        * scale proportional to area of letter
        local dcscale = sqrt(_P_PVdcabs[`i'])/.4 // .4 empirically determined
        if ("`OPTmsize'"!="") local dscale = `OPTmsize'
        local dcscale = string(`dcscale',"%11.3f")
        if ("`OPTdchange'"=="") local dcscale = 1 // all same size
        if "`_ordc[_plot_type_]'"=="dcplot" {
            local dcscale = 1 // all same size
            if ("`OPTmsize'"!="") local dcscale = `OPTmsize'
        }
        local txt `"text(`yis' `xis' "`ltris'", place(c)"'
        local txt `"`txt' size(*`dcscale') color(`ltrcolor'))"'
        local txtall `"`txtall' `txt'"'

        if ("`OPTnosign'"=="") & (`dcis'<0) ///
             & ("`_ordc[_plot_type_]'"=="orplot") {
            local txt `"text(`yis' `xis' "_", place(c)"'
            local txt `"`txt' size(*`dcscale') color(`ltrcolor'))"'
            local txtall `"`txtall' `txt'"'
        }
    }
    char _ordc[plt_markers_text] `"`txtall'"'

//  aspect ratios

    if (`OPTaspect'>0) local aspect "aspectratio(`OPTaspect')"

//  axes labels for orplot

    if "`_ordc[_plot_type_]'"=="orplot" {

        local xtitlebot ///
          "Logit Coefficient Scale Relative to Category `_ordc[plt_baseNM]'"
        local xtitletop ///
          "Odds Ratio Scale Relative to Category `_ordc[plt_baseNM]'"

        if "`OPTxlines'"!="" {
            local OPTxlines `"xline(`OPTxlines') "'
        }

        local axis2 = 2
        local xlabel1 `"`_ordc[plt_xticBvalues]',axis(1)"'
        local xlabel2 `"`_ordc[plt_xticORvalues]',axis(`axis2')"'
        local xtitle2 `"`xtitletop', axis(`axis2') size(medsmall)"'
        local xtitle1 `"`xtitlebot',size(medsmall) just(left)"'

    }

//  axes labels for dcplot

    if "`_ordc[_plot_type_]'"=="dcplot" {

        local xtitletop "Discrete Change in Outcome Probability"
        local xtitlebot ""

        if "`OPTxlines'"=="" local OPTxlines `"xline(0, lcolor(gs12)) "'

        local axis2 = 1 // don't use second axis

        local xlabel1 `"`_ordc[plt_xticBvalues]',axis(1)"'
        local xtitle1 `""`xtitlebot'",size(medsmall) just(left)"'

        local xlabel2 ""
        local xtitle2 `""`xtitletop'", axis(`axis2') size(medsmall)"'

    }

//  tune OPTlinegapfac

    local linegapfac = `OPTlinegapfac' * 2.75 // determine empirically

// create graph commands from user options

    foreach t in note title subtitle caption {
        if "`OPT`t''"!="" {
            local `t'text `"`t'(`OPT`t'')"'
        }
        else local `t'text ""
    }

// dummy data for creating dummy plot for second axis

    tempvar ydata xdata showline
    qui gen `ydata' = 1 in 1
    qui gen `xdata' = 0 in 1
    qui gen `showline' = .

    * if packed, no connecting lines
    if "`OPTpacked'"=="packed" {
        qui replace `showline' = (0*_P_PVcatSig)
    }
    else {
        qui replace `showline' = _P_PVcatSig
    }
    local lcol1 : word 1 of `OPTlcolor'
    local lcol2 : word 2 of `OPTlcolor'
    local lcol3 : word 3 of `OPTlcolor'
    local lcol4 : word 4 of `OPTlcolor'
    local lcol5 : word 5 of `OPTlcolor'
    local lwidth1 : word 1 of `OPTlwidth'
    local lwidth2 : word 2 of `OPTlwidth'
    local lwidth3 : word 3 of `OPTlwidth'
    local lwidth4 : word 4 of `OPTlwidth'
    local lwidth5 : word 5 of `OPTlwidth'

    //  graph commands

    #delimit ;

      twoway

        // connecting lines for non-significant contrast

        (
         pccapsym _P_PVcatYfrom _P_PVcatXfrom _P_PVcatYto _P_PVcatXto
            if `showline'==1, legend(off)

            // lines connecting markers
            lcol(`lcol1') lwid(`lwid1') lpat(solid)

            // circles whiting out lines near markers
            mcol(white) msymb(circle) msiz(*`linegapfac')

            // user specified graph options
            `OPTgraph'
        )
        (
         pccapsym _P_PVcatYfrom _P_PVcatXfrom _P_PVcatYto _P_PVcatXto
            if `showline'==2, legend(off)

            // lines connecting markers
            lcol(`lcol2') lwid(`lwid2') lpat(solid)

            // circles whiting out lines near markers
            mcol(white) msymb(circle) msiz(*`linegapfac')

            // user specified graph options
            `OPTgraph'
        )
        (
         pccapsym _P_PVcatYfrom _P_PVcatXfrom _P_PVcatYto _P_PVcatXto
            if `showline'==3, legend(off)

            // lines connecting markers
            lcol(`lcol3') lwid(`lwid3') lpat(solid)

            // circles whiting out lines near markers
            mcol(white) msymb(circle) msiz(*`linegapfac')

            // user specified graph options
            `OPTgraph'
        )
        (
         pccapsym _P_PVcatYfrom _P_PVcatXfrom _P_PVcatYto _P_PVcatXto
            if `showline'==4, legend(off)

            // lines connecting markers
            lcol(`lcol4') lwid(`lwid4') lpat(solid)

            // circles whiting out lines near markers
            mcol(white) msymb(circle) msiz(*`linegapfac')

            // user specified graph options
            `OPTgraph'
        )
        (
         pccapsym _P_PVcatYfrom _P_PVcatXfrom _P_PVcatYto _P_PVcatXto
            if `showline'==5, legend(off)

            // lines connecting markers
            lcol(`lcol5') lwid(`lwid5') lpat(solid)

            // circles whiting out lines near markers
            mcol(white) msymb(circle) msiz(*`linegapfac')

            // user specified graph options
            `OPTgraph'
        )

        // plot x axis labels for logit coefficients
        (
         scatter `ydata' `xdata',

            msymbol(none) legend(off) `aspect'
            xlabel(`xlabel1')
            xtitle(`xtitle1')
            ylabel(`_ordc[plt_ytic_labels]', angle(horiz) noticks nogrid)
        )

        // plot category markses and x axis labels for odds ratios
        (
         scatter _P_PVvarnumoffset _P_PVbeta,

            msymbol(none)
            `_ordc[plt_markers_text]'
            `_ordc[plt_coeftype_text]'
            xaxis(`axis2') xlabel(`xlabel2') xtitle(`xtitle2')
            `OPTxlines'
            ytitle("") ytitle(, size(small))
            yline(`_ordc[plt_ylinevalues]',
                lwidth(vthin) lpattern(solid) lcolor(black))
            `titletext' `subtitletext' `notetext' `captiontext'
        )
        ;
        #delimit cr

    sreturn local error = 0

*TRACE di in blue _new "  = 2 graph => Leaving _ordcplot_graph"

end // _ordcplot_graph
exit

HISTORY

* version 0.3.5v2 2012-08-05 prior to moveing stuff from *data.aod
* version 0.3.5 2012-08-03 scott long
* version 0.3.6 2012-08-05 moved graph options from data.ado
* version 0.3.8a 2012-08-06 offsetlist
* version 0.3.8 2012-08-06 multple line colors in connects
* version 0.3.7 debug during examples
* version 0.3.9 working version
