*! 0.8.6 2013-02-14 | long freese | start end valid names; fix labels
* 0.8.5 2013-02-14 | long freese | dc->chng name missed; print in amount order
* 0.8.4 2013-02-14 | long freese | dc->chng
* 0.8.3 2013-02-13 | long freese | bystat; new names; r(table)

//  discrete change using margins

* TODO1: add outcomes() to specify outcomes to use
* TODO2: average discrete change when categorical
* TODO3: test marginsoptions(); do it with *?
* TODO5: compute sd if svy
* TODO5: check _mchange_plot_dc for contrast variables
* TODO7: contrasts with only base category
* TODO9: Note a#b not allowed if a!=b
* TODO11: verify use with if in e(sample)
* TODO13: allow ame with predict if at is specified

capture program drop mchange
capture program drop parse_amt
capture program drop parse_stat
program define mchange, rclass

    version 11.2
    syntax [varlist(default=none fv)] [if] [in] ,  ///
        [                               ///
        AMount(string) AMOUNTBinary(string) ///
            /// range binary one sd marginal all
        BYSTATistics /// show results in one stat per table
CHANGES(string asis) /// RENAMED to amount
Changetypes(string asis) /// RENAMED to amount
        ATMEANs /// use atmean option for margins
        DECimals(numlist >-1 integer) /// # in output
        MARGINSoptions(string asis) /// passthrough to margins
        OUTcome(string) /// user can specify outcomes TO BE ADDED
        STATS(string asis) /// synonym for statistics
        STATistics(string asis) /// change ul ll z se p start end
        UNCENtered /// uncentered change
        Verbose /// list margins output
        at(string) /// added to end of at()
        brief ///
        delta(real 0) /// delta change instead of sd change
        replace /// replace matrix
        title(string) /// matrix title
        trim(numlist >-1 integer) /// percent to trim from min max
        ]

    tempname blankmatrix b dc se z pvalue ll ul lvl start end atmat mat
    tempname v outmat1var tmp outmatall atmat pbase varinfo iscat betainfo
    tempname atVary atCons atVary2 atCons2 atVary1 atCons1
    tempname tabdc tabend tabstart tabse tabz tabpvalue tabul tabll
    tempname vecis mattab change

    if "`changes'"!="" | "`changetypes'"!="" {
        display as error "changetypes() was renamed to amount()"
        exit
    }

//  convert amount and stat abbreviations

    local amountbin "`amountbinary'"

    * default amounts for continuous variables
    if "`amount'"!="" {
        local new ""
        foreach opt in `amount' {
            parse_amt `opt'
            local newopt
            local amt "`s(amount)'"
            local new "`new'`amt' "
            if "`s(isbad)'"=="1" {
                display as error "invalid amount specified: `opt'"
                exit
            }
        }
        local amount "`new'"
    }

    * default amount for binary variables
    if "`amountbin'"!="" {
        local new ""
        foreach opt in `amountbin' {
            parse_amt `opt'
            local newopt
            local amt "`s(amount)'"
            local new "`new'`amt' "
            if "`s(isbad)'"=="1" {
                display as error "invalid amount specified: `opt'"
                exit
            }
        }
        local amountbin "`new'"
    }

//  synonyms for stats; verify selections

    if ("`stats'"!="" & "`statistics'"=="") local statistics "`stats'"
    if "`statistics'"!="" {
        local new ""
        foreach opt in `statistics' {
            parse_stat `opt'
            local newopt
            local stat "`s(stat)'"
            local new "`new'`stat' "
            if "`s(isbad)'"=="1" {
                display as error "invalid statistic specified: `opt'"
                exit
            }
        }
        local statistics "`new'"
    }
    if ("`s(isbad)'"=="1") exit

//  program sestup

    estimates store _mchange_model // last model estiamted
    local dopreserve "off"
    local matstub "_mchange"
    local dropmat = 1
    if "`e(cmd)'"=="" | "`e(cmd)'"=="margins" {
        display as error "no estimation command is in memory"
        exit
    }

//  information about the estimation command and variables

    _rm_modelinfo
    matrix `varinfo' = r(varinfo)
    matrix `betainfo' = r(betainfo)
    local varinfonms : colnames `varinfo'
    local betainfonms : colnames `betainfo'

    * varnms correspond to expanded factor names (e.g., 1.hc)
    local varnms "`r(rhsnms)'"
    * varlist changes 1.x to i1.x which margins doesn't like...
    forvalues i = 0(1)9 {
        local varlist : subinstr local varlist "i`i'." "`i'.", all
    }
    if ("`varlist'"!="") local varnms "`varlist'"
    local nvarnms = wordcount("`varnms'")

    * type of each variable: b is binary; c is continuous
    local vartype ""
    foreach varnm in `varnms' {
        capture assert `varnm' == 0 | `varnm' == 1 | `varnm' == . ///
                `if' `in'
        local isbin = _rc==0
        if (`isbin'==1) local vartype "`vartype'b "
        else local std "`std'c "
    }

    local cmdbin = `r(cmdbin)'
    local cmdcrm = `r(cmdcrm)' // count model
    local lhsncats = `r(lhscatn)'
    if ("`cmdcrm'"=="1") local lhsncats = 1
    local lhsnm "`r(lhsnm)'"
    local lhscatnms "`r(lhscatnms)'"
    if ("`cmdcrm'"=="1") local lhscatnms "Rate"
    local lhscatvals "`r(lhscatvals)'"
    local cmdnm "`r(cmdnm)'"
    local cmdttl "`cmdnm'"
    local cmdsvy = `r(cmdsvy)'
    if (`cmdsvy') local cmdttl "svy `cmdttl'"

//  decode options

    if ("`verbose'"=="verbose") local verbose "noisily"
    if ("`if'"=="") local if "if e(sample)==1"
    else local if "`if' & e(sample)==1"
    if ("`title'"=="") local titlenm ///
        "`cmdttl': Changes in Probabilities for `lhsnm'"
    else local titlenm "`title'"
    local samplenote ""
    if "`if'"!="" & "`if'"!="if e(sample)==1" {
        local samplenote "`samplenote' `if'"
    }
    if ("`in'"!="") local samplenote "`samplenote'; `in'"
    if ("`trim'"=="") local trim = 0
    if (`trim'==0) local trimnote "Range computed without trimming."
    if (`trim'!=0) local trimnote "Range trimmed by `trim' percent."
    local deltanote ""
    if (`delta'!=0) local deltanote "Delta equals `delta'."
    if ("`decimals'"=="") local decimals = 4 // to match pr commands
    if ("`uncentered'"=="uncentered") local cntr_nm "unctr"
    else local cntr_nm "cntr"
    if (`delta'!=0) local sd_nm   "delta"
    else local sd_nm "SD"

//  amounts and their labels

    * amount labels for output
    local Clbl_bin "0 to 1"
    local Clbl_one "+1 `cntr_nm'"
    local Clbl_sd "+`sd_nm' `cntr_nm'"
    local Clbl_marg "Marginal"
    if (`trim'==0) local Clbl_rng "Range"
    else local Clbl_rng "Trimmed range"

    * sets of amounts
    local Cset_all "bin one sd rng marg" // all types in print order
    local Cset_dc  "bin one sd rng" // all dc types
    local Cset_bin "bin" // default for binary
    if ("`amountbin'"!="") local Cset_bin "`amountbin'"
    local Cset_con "one sd marg" // default for continuous
    if ("`amount'"!="") local Cset_con "`amount'"
    local Cshow_bin "`Cset_bin'"
    local Cshow_con "`Cset_con'"
    * only need to preserve data if -+1 or -+sd change
    foreach chng in `Cshow_con' {
        if ("`chng'"=="one" | "`chng'"=="sd" ) & "`atmeans'"!="" {
            local dopreserve "yes"
        }
    }
    local ipos : list posof "rng" in Cshow_con
    local C_isrng = `ipos'>0
    local Cshow_binNOdy = subinword("`Cshow_bin'", "marg", "", .)
    local Cshow_conNOdy = subinword("`Cshow_con'", "marg", "", .)

    * matrix row offsets for types of changes
    local Cmat_order "rng bin one sd marg" // row order in matrix
    local mat_off_rng  = 1
    local mat_off_bin  = 2
    local mat_off_one  = 3
    local mat_off_sd   = 4
    local mat_off_marg = 5
    local irowbin = 0
    local irowcon = 0
    * row names for output matrix in order defined above
    local C_rownms `""`Clbl_rng'" "`Clbl_bin'""'
    local C_rownms `"`C_rownms' "`Clbl_one'" "`Clbl_sd'" "`Clbl_marg'""'
    * _ for space in labels
    local C_rownms_ : subinstr local C_rownms " " "_", all
    local C_rownms_ : subinstr local C_rownms_ `"_""' `" ""', all
    local C_rownms_ : subinstr local C_rownms_ `""_"' `"" "', all

    * offsets for printing
    foreach chng in `Cmat_order' {
        local ipos : list posof "`chng'" in Cshow_bin
        if `ipos'>0 {
            local ++irowbin
            local prtbin_off_`chng' = `irowbin'
        }
        else local prtbin_off_`chng' = 0
        local ipos : list posof "`chng'" in Cshow_con
        if `ipos'>0 {
            local ++irowcon
            local prtcon_off_`chng' = `irowcon'
        }
        else local prtcon_off_`chng' = 0
    }

//  classify types of beta's: i.catvar and interactions
//      i.catvar handled with margins, pwcompare
//      a#b only processed by mtable if it is quadratic only interaction

    * check names
    local badnms ""
    local error = 0
    foreach varnm in `varnms' {
        local ipos : list posof "`varnm'" in betainfonms
        if `ipos'==0 {
            local badnms "`badnms'`varnm' "
            local error = 1
        }
    }
    if `error' {
        display as error ///
        "`badnms'not in model; indicate factor variables as #.varname"
        exit
    }

    * create lists of type of each variable
    local binvarlist "" // i.binvar names
    local catvarlist "" // i.catvar names
    local intanylist ""
    local intdroplist ""
    local intquadcorelist ""
    local intquadbetalist ""
    foreach varnm in `varnms' {
        local nm : subinstr local varnm "." "_", all
        local nm : subinstr local nm "#" "_", all
        local is`nm'bin = 0 // i.binvar
        local is`nm'cat = 0 // i.catvar
        local is`nm'intany = 0 // any a#b
        local is`nm'intdrop = 0 // a#b where a!=b
        local is`nm'intquad = 0 // a#b where a==b and never a!=b (quadratic)
        local ipos : list posof "`varnm'" in betainfonms
        if `ipos'>0 {
            * i.binary
            local Bisbin = `betainfo'[1,`ipos']
            if `Bisbin'==1 {
                local is`nm'bin = 1
                local binvarlist "`binvarlist'`varnm' "
            }
            * i.categorical
            local Biscat = `betainfo'[2,`ipos']
            if `Biscat'==1 {
                local is`nm'cat = 1
                _ms_parse_parts `varnm'
                local catvarlist "`catvarlist'`r(name)' "
            }
            * any interaction
            local Bisintany = `betainfo'[7,`ipos']
            if `Bisintany'==1 {
                local is`nm'intany = 1
                _ms_parse_parts `varnm'
                local intanylist "`intanylist'`r(name)' "
            }
            * interaction only as quadratic
            local Bintquad = `betainfo'[9,`ipos']
            if `Bintquad'==1 {
                local is`nm'intquad = 1
                _ms_parse_parts `varnm'
                local intquadcorelist "`intquadcorelist'`r(name)' `r(name1)'"
                local intquadbetalist "`intquadbetalist'`varnm' "
            }
            * interaction other than quadratic; drop this later
            local Bintdrop = `betainfo'[10,`ipos']
            if `Bintdrop'==1 {
                local is`nm'intdrop = 1
                _ms_parse_parts `varnm'
                local intdroplist "`intdroplist'`r(name)' "
            }
/*
di "nm: `nm'"
di "              cat[`is`nm'cat']"
di "              bin[`is`nm'bin']"
di "           intany[`is`nm'intany']"
di "          intquad[`is`nm'intquad']"
di "         intdrop[`is`nm'intdrop']"
*/
        }

        local intquadcorelist : list uniq intquadcorelist
    } // var loop

    if "`intdroplist'"!="" {
        local intdropnote "Due to interactions these variables not included:"
        local intdropnote2 "  : `intdroplist'"
    }
/*
di "intdroplist: `intdroplist'"
di "intquadcorelist: `intquadcorelist'"
di "intquadbetalist: `intquadbetalist'"
di "binvarlist: `binvarlist'"
*/

//  redefine varnms for later processing

    local varnmsmain "" // standard processing
    local betanmscat "" // process with margins, pwcompare
    local varnmscat "" // process with margins, pwcompare
    local varnmsdrop "" // not processed by mchange
    local varnmsquad "" // quad terms where only src var kept
    local varnmsquadsrc "" // source vars for quad terms
    foreach varnm in `varnms' { // these are names from e(b) columns
        local nm : subinstr local varnm "." "_", all
        local nm : subinstr local nm "#" "_", all
        * is it i.catvar?
        if `is`nm'cat' == 1 {
            local betanmscat "`betanmscat'`varnm' "
            _ms_parse_parts `varnm'
            local varnmscat "`varnmscat'`r(name)' "
        }
        * is it #quadratic
        else if `is`nm'intquad' == 1 {
            _ms_parse_parts `varnm'
            * keep only source variable
            local varnmsmain "`varnmsmain'`r(name1)' "
            local varnmsquadsrc "`varnmsquadsrc'`r(name1)' "
            local varnmsquad "`varnmsquad'`varnm' "
        }
        * other interactions are dropped
        else if `is`nm'intdrop' == 1 {
            local varnmsdrop "`varnmsdrop'`varnm' "
        }
        * keep rest
        else {
            local varnmsmain "`varnmsmain'`varnm' "
        }
    }
    local varnmsmain : list uniq varnmsmain
    local varnmsquadsrc : list uniq varnmsquadsrc
    local varnmscat : list uniq varnmscat
    if "`varnmsquadsrc'"!="" {
        local n = wordcount("`varnmsquadsrc'")
        if `n'==1 {
            local quadnote ///
            "Variable `varnmsquadsrc' has quadratic terms in model."
        }
        else {
            local quadnote ///
            "Variables `varnmsquadsrc' have quadratic terms in model."
        }
    }
/*
di "varnmsmain: `varnmsmain'"
di "varnmscat : `varnmscat'"
di "betanmscat: `betanmscat'"
di "varnmsdrop: `varnmsdrop'"
di "varnmsquad: `varnmsquad'"
*/
    if ("`varnmsmain'"=="") local nomainvars = 1
    else local nomainvars = 0
    if ("`varnmsmain'"!="") local mainvars = 1
    else local mainvars = 0

//  assign locations in output and matrix

    local ivar = 0
    local iprtrow = 0
    foreach varnm in `varnmsmain' {
        local varn_ : subinstr local varnm "." "_", all // remove . from name
        local varn_ : subinstr local varn_ "#" "_", all // remove #. from name
        capture assert `varnm'==0 | `varnm'==1 | `varnm'==. `if' `in'
        local isbin_`varn_' = (_rc==0) // is a binary predictor
        local ++ivar
        local varstart = (`ivar'-1)*5 // 5 types of changes
        foreach chng in `Cset_all' {
            * mat_<chng>_<var> : output mat row# for chng+var pair
            local mat_`chng'_`varn_' = `varstart' + `mat_off_`chng''
*di "`chng'  mat_`chng'_`varn_' = `mat_`chng'_`varn_''"
        }
        foreach chng in `Cset_all' {
            if `isbin_`varn_''==1 {
                local ipos : list posof "`chng'" in Cshow_bin
                if `ipos'>0 {
                    local ++iprtrow
                    * prt_<chng>_<var> : print row# for chng+var pair
                    local prt_`chng'_`varn_' = `iprtrow'
                }
                else local prt_`chng'_`varn_' = 0
            }
            else {
                local ipos : list posof "`chng'" in Cshow_con
                if `ipos'>0 {
                    local ++iprtrow
                    local prt_`chng'_`varn_' = `iprtrow'
                }
                else local prt_`chng'_`varn_' = 0
            }
*di "`chng'  prt_`chng'_`varn_' = `prt_`chng'_`varn_''"
        }
    } // var loop
    local maxprintrow = `iprtrow'

//  controls for statistics types

    * labels for output
*dc
    local Slbl_change "Change"
    local Slbl_ul "UL"
    local Slbl_ll "LL"
    local Slbl_z "z-value"
    local Slbl_se `"Std. Err."'
    local Slbl_pvalue "P>|z|"
    local Slbl_start "From"
    local Slbl_end "To"

    * sets of stats
*dc
    local S_all "change pvalue ul ll z se start end"
    local S_nostrtend "change pvalue ul ll z se"
    local S_default "change pvalue"
    local S_show "`statistics'"
    if ("`S_show'"=="") local S_show "`S_default'"
    if ("`S_show'"=="all") local S_show "`S_all'"

    local ipos : list posof "ul" in S_show
    local S_isul = `ipos'>0
    local ipos : list posof "ll" in S_show
    local S_isll = `ipos'>0

//  matrices to hold results

    * 5 rows X ncats for each variable (i.e. e(b) parameter)
    matrix `outmat1var' = J(5,`lhsncats',.z)
    matrix rownames `outmat1var' = `C_rownms'
    matrix colnames `outmat1var' = `lhscatnms'
    * stack matrices for each variable
    foreach varnm in `varnmsmain' { // FV
        local nm : subinstr local varnm "." "_", all
        local nm : subinstr local nm "#" "_", all
        matrix roweq `outmat1var' = `varnm' // name for output labeling
        matrix `outmatall' = nullmat(`outmatall') \ `outmat1var'
    }

    if `dropmat' {
        capture matrix drop `matstub'
        foreach s in `S_all' {
            capture matrix drop `matstub'_`s'
        }
    }
    else {
        capture matrix list `matstub'
        if _rc==0 {
            display as error ///
            "matrix `matstub' exists; choose another name or delete matrix"
            exit
        }
        * else matrix drop `matstub'
        else capture matrix drop `matstub'
        foreach s in `S_all' {
            capture matrix list `matstub'_`s'
            if _rc==0 {
                display as error "matrix `matstub'_`s' exists;" ///
                "choose another name or delete matrix"
                exit
            }
            else capture matrix drop `matstub'_`s'
        }
    }
    if `mainvars' {
        foreach stat in end `S_all' {
            matrix `matstub'_`stat' = `outmatall'
            matrix coleq `matstub'_`stat' = `stat'
        }
    }

//  get at matrix

    //  NOTE: atmat is used as the base values in computing changes when
    //  values for a variable are in the at matrix (e.g., when at(dog=12)
    //  12 is used for dog. In other cases the mean is computed as the
    //  default base value.

    qui {
        local OutcomeName "`e(depvar)'"
        qui sum `OutcomeName'
        local MinValue = r(min)
        tempvar TestVariable
        capture quietly predict `TestVariable', outcome(`MinValue')
        if _rc == 0 {
            local MarginPred "predict(outcome(`MinValue'))"
        }
        `verbose' ///
            margins `if' `in', at(`at') `atmeans' `marginsoptions' `MarginPred'
        local p1base = el(r(b),1,1) // used for base predictions
        local isat = 0
        capture matrix list r(at)
        if _rc==0 {
            quietly mlistat, saveconstant(atmat)
            local isat = `s(isconstant)' // at matrix with fixed values
            if `isat'==1 {
                matrix rownames atmat = "at"
                matrix `atmat' = atmat
                capture matrix drop atmat
            }
            local atmatcolnms : colnames `atmat'
        }
    } // quietly

//  compute changes

    * used to hold start and end values for AME for one and sd
    tempvar varsd_F varsd_T varone_F varone_T varone_DC varsd_DC varinsamp
    tempvar origvar predictF predictT predictDC
    qui {
        * use with margins for AME
        gen `varinsamp' = 1 `if' `in'
        gen `varsd_DC' = .
        gen `varsd_F' = .
        gen `varsd_T' = .
        gen `varone_DC' = .
        gen `varone_F' = .
        gen `varone_T' = .
        lab var `varsd_DC' "sd DC"
        lab var `varone_DC' "one DC"
        lab var `varsd_F' "x - sd/2"
        lab var `varone_F' "x - 1/2"
        lab var `varsd_T' "x + sd/2"
        lab var `varone_T' "x + 1/2"
        * 0.8.1 using predict
        gen `origvar' = .
        label var `origvar' "change variable before manipulation for AME"
    }
    local nobs = _N
    local isatopt = 0
    if "`marginsoptions'"!="" local isatopt = 1
    if "`at'"!="" local isatopt = 1

    * in cases data is changed using counterfactual with AME
    if "`dopreserve'"=="yes" {
        preserve
    }

    qui {
    local varnum = 0

// loop over vars

    foreach varnm in `varnmsmain' {

        replace `origvar' = `varnm'
        local varn_ : subinstr local varnm "." "_", all
        local varn_ : subinstr local varn_ "#" "_", all
        local ++varnum
        * get non-fv name and check if 1. variable; remove i. too
        local varnm_nofv = regexr("`varnm'","[0-9i]+\."," ")
        local isfvbin = `is`varn_'bin'

        //  base values are from r(at) if possible. With atmeans
        //  all vars have r(at) values. Without atmeans only variables
        //  in at() have values; in that case compute mean.
        sum `varnm' `if' `in'
        local mn = r(mean)
        local sd2 = r(sd)/2
        if (`delta'!=0) local sd2 = `delta'/2
        if `trim'==0 {
            local rng_F = r(min) // works for svy too
            local rng_T = r(max)
        }
        else { // trim
            if `cmdsvy' {
                display as error "trim() cannot be used with svy estimation"
                local error = 1
                continue, break
            }
            local trimUB = 100 - `trim'
            centile `varnm' `if' `in', centile(`trim' `trimUB')
            local rng_F = r(c_1)
            local rng_T = r(c_2)
        }

* TODO: get sd with svy
        if `cmdsvy' {
            capture svy : mean  `varnm' `if' `in'
            if _rc!= 0 {
                display as error "error using svy : mean"
                display as error ///
                    "svy : mean does not work with factor variables"
                exit _rc
                continue
            }
            estat sd
            matrix `mat' = r(mean)
            local mn = `mat'[1,1]
            matrix `mat' = r(sd)
            local sd2 = `mat'[1,1]/2
        }

        local atval = .
        capture matrix list `atmat'
        if _rc==0 { // r(at) exists
            local icol : list posof "`varnm'" in atmatcolnms
            local atval = `atmat'[1,`icol']
        }
        if (`atval'==.) local baseval = `mn'
        else local baseval = `atval'

        //  determine F_rom values and T_o values for changes

        local bin_F = 0
        local bin_T = 1
        if "`uncentered'"=="" {
            local one_F = `baseval' - .5
            local one_T = `baseval' + .5
            local sd_F  = `baseval' - `sd2'
            local sd_T  = `baseval' + `sd2'
        }
        else { // uncentered
            local one_F = `baseval'
            local one_T = `baseval' + 1
            local sd_F  = `baseval'
            local sd_T  = `baseval' + `sd2' + `sd2'
        }

        * at() values for all dc types
        foreach chng in `Cset_dc' {
            local at_`chng' "``chng'_F' ``chng'_T'"
        }

        //  loop over categories and compute margins

        local catnum = 0
        if (`cmdbin'==1) local lhscatvals "1" // if 0 1, only compute 1
        if (`cmdcrm'==1) local lhscatvals "1" // if 0 1, only compute 1
        foreach catval in `lhscatvals' {
            if `cmdbin'==1 {
                local catnum = 2 // save pr(1) in col 2
                local optpredict ""
            }
            else if `cmdcrm'==1 {
                local catnum = 1 // save mu in col 1
                local optpredict ""
            }
            else {
                local ++catnum
                local optpredict "predict(outcome(`catval'))"
            }

            local ichng = 0
//  loop through changes
            foreach chng in `Cset_all' { // loop through change types
*di "chng: `chng' starting to compute"
                * if sd or one and not atmeans, must loop through data
                local doloop = 0
                if (("`chng'"=="one") | ("`chng'"=="sd")) ///
                        & ("`atmeans'"!="atmeans") {
                    local doloop = 1
                }

            * not marg
            if (`prt_`chng'_`varn_''>0) & ("`chng'"!="marg") {
                local ++ichng
                estimates restore _mchange_model
                * at() list no dealing with 1. variables
                local atFromTo "`varnm_nofv'=(`at_`chng'')"
                local domargins = 1
                * with binary fv can't do +-1 or +-sd change
                if (`isfvbin'==1 & "`chng'"=="one") local domargins = 0
                if (`isfvbin'==1 & "`chng'"=="sd") local domargins = 0

                * for bin, marg & range no need to loop through data
                if (`domargins'==1) & (`doloop'==0) {
                    `verbose' margins `if' `in', at(`atFromTo' `at') ///
                        `atmeans' `marginsoptions' post `optpredict'
                    `verbose' lincom _b[2._at] - _b[1._at]
                    _rm_lincom_stats
                    scalar `start' = _b[1._at]
                    scalar `end' = _b[2._at]
*dc
                    scalar `change' = r(est)
                    scalar `se' = r(se)
                    scalar `z' = r(z)
                    scalar `pvalue' = r(p)
                    scalar `ll' = r(lb)
                    scalar `ul' = r(ub)
                    scalar `lvl' = r(level)
                    estimates restore _mchange_model
                } // margins with no loop

                * AME sd & 1 using predict if no at specified
                else if (`domargins'==1) & (`doloop'==1) & (`isatopt'==0) {
                    if ("`lhscatvals'"=="1") local predictout ""
                    else local predictout "outcome(`catval')"
                    scalar `se' = .
                    scalar `z' = .
                    scalar `pvalue' = .
                    scalar `ll' = .
                    scalar `ul' = .
                    scalar `lvl' = .
                    scalar `start' = .
                    scalar `end' = .
                    if "`uncentered'"=="" & "`chng'"=="one" {
                        local deltaF = .5
                        local deltaT = .5
                    }
                    if "`uncentered'"=="" & "`chng'"=="sd" {
                        local deltaF = `sd2'
                        local deltaT = `sd2'
                    }
                    if "`uncentered'"!="" & "`chng'"=="one" {
                        local deltaF = 0
                        local deltaT = 1
                    }
                    if "`uncentered'"!="" & "`chng'"=="sd" {
                        local deltaF = 0
                        local deltaT = `sd2' + `sd2'
                    }
                    replace `varnm' = `origvar' - `deltaF'
                    capture drop `predictF'
                    predict `predictF' `if', `predictout'
                    replace `varnm' = `origvar' + `deltaT'
                    capture drop `predictT'
                    predict `predictT' `if', `predictout'
                    capture drop `predictDC'
                    gen `predictDC' = `predictT' - `predictF'
                    sum `predictDC'
*dc
                    scalar `change' = r(mean)
                    replace `varnm' = `origvar'
                } // AME 1 & SD with predict
                else if (`domargins'==1) & (`doloop'==1) & (`isatopt'==1) {
di "Note: AME with at() and other options for change types sd and one"
di "can be very slow. AME for marg or bin is much faster."
                    forvalues iobs = 1(1)`nobs' {
                      local isin = `varinsamp'[`iobs']
                      if `isin'==1 {
                        local varis = `varnm'[`iobs']
                        if "`uncentered'"=="" {
                          local one_F = `varis' - .5
                          local one_T = `varis' + .5
                          local sd_F  = `varis' - `sd2'
                          local sd_T  = `varis' + `sd2'
                        }
                        else { // uncentered
                          local one_F = `varis'
                          local one_T = `varis' + 1
                          local sd_F  = `varis'
                          local sd_T  = `varis' + `sd2' + `sd2'
                        }
                        local atFromTo "`varnm_nofv'=(``chng'_F' ``chng'_T')"
                        * margins is slow but use at() and other options
                        `verbose' margins in `iobs', at(`atFromTo' `at') ///
                            `atmeans' `marginsoptions' `optpredict'
                        scalar `start' = el(r(b),1,1)
                        scalar `end' = el(r(b),1,2)
*dc
                        scalar `change' = `end' - `start'
                        qui replace `var`chng'_F' = `start' in `iobs'
                        qui replace `var`chng'_T' = `end' in `iobs'
*dc
                        qui replace `var`chng'_DC' = `change' in `iobs'
                        scalar `se' = .
                        scalar `z' = .
                        scalar `pvalue' = .
                        scalar `ll' = .
                        scalar `ul' = .
                        scalar `lvl' = .
                      } // in sample
                    } // obs loop
                    * compute effect
                    qui sum `var`chng'_DC'
*dc
                    scalar `change' = r(mean)
                } // AME sd & one with at()

                * do not compute
                else {
                    scalar `start' = .
                    scalar `end' = .
*dc
                    scalar `change' = .
                    scalar `se' = .
                    scalar `z' = .
                    scalar `pvalue' = .
                    scalar `ll' = .
                    scalar `ul' = .
                    scalar `lvl' = .
                }

                * save to matrix
                foreach stat in `S_all' {
                    matrix `matstub'_`stat'[`mat_`chng'_`varn_'',`catnum'] ///
                      = ``stat''
                }
            } // if print and not marg
        } // over changes

//  partial

        if `prt_marg_`varn_''>0 {
            estimates restore _mchange_model
            * fv fix: remove i. 1. etc.
            local varnm_nofv = regexr("`varnm'","[0-9i]+\."," ")
            `verbose' margins `if' `in', dydx(`varnm_nofv') ///
                at(`at') `atmeans' post `marginsoptions' `optpredict'
*dc
            scalar `change' = el(r(table),1,1)
            scalar `se' = el(r(table),2,1)
            scalar `z' = el(r(table),3,1)
            scalar `pvalue' = el(r(table),4,1)
            scalar `ll' = el(r(table),5,1)
            scalar `ul' = el(r(table),6,1)
            scalar `start' = .
            scalar `end' = .
            scalar `lvl' = r(level)
            foreach stat in `S_all' {
                matrix `matstub'_`stat'[`mat_marg_`varn_'',`catnum'] ///
                    = ``stat''
            }
            estimates restore _mchange_model
        } // if partial
        local lvlis = `lvl'
        local CInote "CI computed at `lvlis' percent level."
      } // loop over catval
    } // over varnm
    } // quietly

    if (`error'==1) exit

//  bystat: matrices with results in bystat

    foreach stat in `S_all' {
        foreach varnm in `varnmsmain' {
            local varn_ : subinstr local varnm "." "_", all
            local varn_ : subinstr local varn_ "#" "_", all
* foreach chng in `Cset_all' {
* print in specified order
            foreach chng in `Cshow_con' `Cshow_bin' {
                if `prt_`chng'_`varn_''>0 {
                    matrix _bystat_`stat' = nullmat(_bystat_`stat') ///
                        \ `matstub'_`stat'[`mat_`chng'_`varn_'',1...]
                }
            } // chng
        } // varnm
    } // stat

    if `cmdbin' & `mainvars' {
        foreach stat in `S_show' {
            matrix coleq _bystat_`stat' = ""
            matrix coln _bystat_`stat' = `""`Slbl_`stat''""'
            * col 2 has pr(1); col 1 has pr(0)
            matrix _bystat_ = nullmat(_bystat_) , _bystat_`stat'[1...,2]
        }
    }

//  byvar: matrices with results in order byvariable

    capture matrix drop `matstub'_byvar
    if `cmdbin' {
        matrix `matstub'_byvar = _bystat_
    }
    else {
        foreach varnm in `varnmsmain' {
            local varn_ : subinstr local varnm "." "_", all
            local varn_ : subinstr local varn_ "#" "_", all
* foreach chng in `Cset_all' {
* print in amount order
            foreach chng in `Cshow_con' `Cshow_bin' {
*                local notfirst = 0
                foreach stat in `S_show' {
local statnm "`stat'"
if "`stat'"=="pvalue" local statnm "p"
                    if `prt_`chng'_`varn_''>0 {
                        matrix `vecis' = ///
                            `matstub'_`stat'[`mat_`chng'_`varn_'',1...]
                        local rowfullnm : rowfullnames `vecis'
                        local roweqnm : roweq `vecis'
*local notfirst = 1
*                        if `notfirst'==1 {
*di
*di "notfirst"
*di "stat: `stat' roweqnm: `roweqnm'"
                            local rowfullnm "`roweqnm':`statnm'"

*                        }
*                        else {
*                            local rowfullnm "`rowfullnm'"
*di
*di "first"
*di "stat: `stat' roweqnm: `roweqnm' rowfullnm: `rowfullnm'"
*                        }
*di "rowname: `rowfullnm'"
                        matrix rownames `vecis' = "`rowfullnm'"
                        matrix `matstub'_byvar = nullmat(`matstub'_byvar) ///
                            \ `vecis'
                    }
                    local notfirst = 1
                } // stat
            } // chng
        } // varnm
        matrix coleq `matstub'_byvar = ""
    }

//  process categorical variables

    local varnum = 0
*dc
    local cchange = 1
    local cse = 2
    local cz = 3
    local cpvalue = 4
    local cll = 5
    local cul = 6
    qui {
        foreach catvarnm in `varnmscat' {
            local ++varnum
            local catnum = 0
            if (`cmdbin'==1 | `cmdcrm'==1)  local lhscatvals "1"
            foreach catval in `lhscatvals' {
                if `cmdbin'==1 {
                    local catnum = 2 // save pr(1) in col 2
                    local optpredict ""
                }
                else if `cmdcrm'==1 {
                    local catnum = 1 // save mu in col 1
                    local optpredict ""
                }
                else {
                    local ++catnum
                    local optpredict "predict(outcome(`catval'))"
                }
                `verbose' margins `catvarnm'  `if' `in', pwcompare ///
                    at(`at') `atmeans' `marginsoptions' `optpredict'
                matrix pwmat`catval' = r(table_vs)'
            }
            local nrows = colsof(r(table_vs))
            local rownms : colnames r(table_vs)
            local rownms : subinstr local rownms ".`catvarnm'" "", all
            local rownms : subinstr local rownms "vs" "_vs_", all
            forvalues i = 1(1)9 {
                local rownms : subinstr local rownms "`i'bn" "`i'", all
            }
            local S_pwshow = subinword("`S_show'", "start", "", .)
            local S_pwshow = subinword("`S_pwshow'", "end", "", .)
            local S_pwall = subinword("`S_all'", "start", "", .)
            local S_pwall = subinword("`S_pwall'", "end", "", .)
            foreach stat in `S_nostrtend' { // `S_pwshow'
                matrix tempmat = J(`nrows',`catnum',.)
                forvalues irow = 1(1)`nrows' {
                    foreach jcol in `lhscatvals' {
                        local srccol = `c`stat'' // source location
                        scalar stat = pwmat`jcol'[`irow',`srccol']
                        matrix tempmat[`irow',`jcol'] = stat
                    }
                }
                matrix colnames tempmat = `lhscatnms'
                local newnms : subinstr local rownms "vs" "_vs_", all
                local newnms : subinstr local rownms "bn" "", all
                matrix rownames tempmat = `newnms'
                matrix roweq tempmat = `catvarnm'
                matrix pwprt_`stat' = nullmat(pwprt_`stat') \ tempmat
                capture drop tempmat
            }
        } // i.catvars
        capture matrix drop tempmat
    } // qui

    if "`varnmscat'"!="" {
        foreach stat in `S_nostrtend' {
            capture matrix drop `matstub'_pw`stat'
            foreach catvarnm in `varnmscat' {
                matrix `matstub'_pw`stat' = nullmat(`matstub'_pw`stat') ///
                    \ pwprt_`stat'
            }
        }
    }

//  add pwcompare to _bystat_ and _bystat_stat

    if "`varnmscat'"!="" {
        * binary model
        if `cmdbin' {
            foreach stat in `S_pwshow' {
                matrix coleq pwprt_`stat' = ""
                matrix coln pwprt_`stat' = `""`Slbl_`stat''""'
                matrix pwprt_ = nullmat(pwprt_) , pwprt_`stat'[1...,1]
                capture matrix drop pwprt_`stat'
            }
            matrix _bystat_ = nullmat(_bystat_) \ pwprt_
        }
        * not binary
        else {
            *foreach stat in `S_show' {
            foreach stat in `S_all' {
                local ipos : list posof "`stat'" in S_pwall
                if `ipos'>0 {
                    matrix _bystat_`stat' = nullmat(_bystat_`stat') ///
                        \ pwprt_`stat'
                }
            }
        } // not binary
    } // i.catvar

    * nonbinary with catvar
    if "`varnmscat'"!="" & !`cmdbin' {
        tempname matpw
        *dc
        local npwrows = rowsof(pwprt_change)
        forvalues irow = 1(1)`npwrows' {
            local notfirst = 0
            foreach stat in `S_show' {
                local ipos : list posof "`stat'" in S_pwshow
                if `ipos'>0 {
                    matrix `vecis' = pwprt_`stat'[`irow',1...]
                    local rowfullnm : rowfullnames `vecis'
                    local roweqnm : roweq `vecis'
                    if `notfirst'==1 {
                        local rowfullnm "`roweqnm':`stat'"
                    }
                    else {
                        local rowfullnm "`rowfullnm'"
                        local notfirst = 1
                    }
                    matrix rownames `vecis' = "`rowfullnm'"
                    matrix `matpw' = nullmat(`matpw') \ `vecis'
                }
            } // stat
        }
        matrix `matstub'_byvar = `matstub'_byvar \ `matpw'
    } // nonbin catvars

//  print results

    display _new "{sf}`titlenm'" _continue

//  show results by statistic

    if `cmdbin' {
        matlist _bystat_, format(%9.`decimals'f) ///
            title("{bf}`Slbl_`s''{sf}") lines(oneline) underscore
    }

    * not binary
    else {
        * show one statistics per table
        if "`bystatistics'"=="bystatistics" {
            display
            foreach s in `S_show' {
                matrix coleq _bystat_`s' = ""
                matlist _bystat_`s', format(%9.`decimals'f) ///
                    title("{bf}`Slbl_`s''{sf}") lines(oneline) underscore
            }
        } // by stat
        else {
            matlist `matstub'_byvar, format(%9.`decimals'f) ///
                    title("{bf}`Slbl_`s''{sf}") lines(oneline) underscore
        }
    }

//  base values

    if `cmdbin' & "`brief'"=="" {
        local p0base = 1 - `p1base'
        matrix `pbase' = `p0base', `p1base'
        matrix rownames `pbase' = `""Pr(y|base)""'
        matrix colnames `pbase' = `lhscatnms'
        display _new "{sf}Predictions at base values"
        matrix list `pbase', noheader format(%7.`decimals'f)
    }

    if `isat' & "`brief'"=="" {
        * remove b. columns from i. variables
        tempname selmat
        capture matrix drop `selmat'
        local colnms : colnames `atmat'
        foreach icolnm of local colnms {
            local isbdot = 1 - regexm(`"`icolnm'"',"b\.")
            matrix `selmat' = nullmat(`selmat') , `isbdot'
        }
        _rm_matrix_select `atmat' `selmat' col
        * remove missing columns
        _rm_matrix_nomiss `atmat' col  // "`colnames'"
        display as text _new "{sf}Base values of predictors{sf}" // _cont
        matrix rownames `atmat' = `"r(at)"'
        matrix list `atmat', noheader format(%7.`decimals'f)
        display
    }
    else {
        local noconnote "No variables held constant when computing changes."
        display
    }

    if  "`brief'"=="" {
        local i = 1
        if "`atmeans'"=="atmeans" {
            display _col(1) "`i': Estimates with margins option atmeans."
            local ++i
        }
        if "`intdroplist'"!="" {
            display _col(1) "`i': `intdropnote'"
            display _col(4) "`intdropnote2'"
            local ++i
        }
        if "`quadnote'"!="" {
            display _col(1) "`i': `quadnote'"
            local ++i
        }
        if "`noconnote'"!="" {
            display _col(1) "`i': `noconnote'"
            local ++i
        }
        if "`deltanote'"!="" {
            display _col(1) "`i': `deltanote'"
            local ++i
        }
        if "`samplenote'"!="" {
            display _col(1) "`i': `samplenote'"
            local ++i
        }
        if `C_isrng'==1 {
            display _col(1) "`i': `trimnote'"
            local ++i
        }
        if `S_isul'==1 | `S_isll'==1 {
            display _col(1) "`i': `CInote'"
            local ++i
        }
    } // brief

//  cleanup

    qui estimates restore _mchange_model
    foreach catval in `lhscatvals' {
        capture matrix drop pwmat`catval'
    }
    * matrices used for plots
    if `mainvars' {
        *dc
        matrix `matstub'_plot_dc = `matstub'_change // for orplot and dcplot
        matrix `matstub'_plot_pvalue = `matstub'_pvalue // for orplot & dcplot
    }
    foreach stat in `S_all' {
        capture matrix drop pwprt_`stat'
        capture matrix drop `matstub'_pw`stat'
    }

//  return matrices

    if `cmdbin' {
        return matrix table = _bystat_
    }

    * not cmdbin
    else {
        * returns r(statname)
        foreach stat in `S_all' {
            return matrix `stat' = _bystat_`stat'
        }
        return matrix table = `matstub'_byvar
    }
    * cleanup
    foreach stat in `S_all' {
        capture matrix drop `matstub'_`stat'
    }

end

* decode amount
program define parse_amt, sclass
    local isbad = 1
    local amt "`1'"
    local is = inlist("`amt'","r","ra","ran","rang","range","rng")
    if `is'==1 {
        local amt "rng"
        local isbad = 0
    }
    local is = inlist("`amt'","b","bi","bin","bina","binar","binary")
    if `is'==1 {
        local amt "bin"
        local isbad = 0
    }
    local is = inlist("`amt'","1","o","on","one")
    if `is'==1 {
        local amt "one"
        local isbad = 0
    }
    local is = inlist("`amt'","s","sd")
    if `is'==1 {
        local amt "sd"
        local isbad = 0
    }
    local is = inlist("`amt'","m","ma","mar","marg","margi","margin")
    if `is'==1 {
        local amt "marg"
        local isbad = 0
    }
    else {
        local is = inlist("`amt'","margina","marginal","dydx","partial")
        if `is'==1 {
            local amt "marg"
            local isbad = 0
        }
    }
    local is = inlist("`amt'","a","al","all")
    if `is'==1 {
        local amt "rng bin one sd marg"
        local isbad = 0
    }
    sreturn local amount "`amt'"
    sreturn local isbad "`isbad'"
end

program define parse_stat, sclass
    local isbad = 1
    local stat "`1'"
    local is = inlist("`stat'","z","zv","zva","zval","zvalu","zvalue")
    if `is'==1 {
        local stat "z"
        local isbad = 0
    }
    local is = inlist("`stat'","t","tv","tva","tval","tvalu","tvalue")
    if `is'==1 {
        local stat "z"
        local isbad = 0
    }
    local is = inlist("`stat'","from")
    if `is'==1 {
        local stat "start"
        local isbad = 0
    }
    local is = inlist("`stat'","st","sta","star","start")
    if `is'==1 {
        local stat "start"
        local isbad = 0
    }
    local is = inlist("`stat'","to")
    if `is'==1 {
        local stat "end"
        local isbad = 0
    }
    local is = inlist("`stat'","en","end")
    if `is'==1 {
        local stat "end"
        local isbad = 0
    }
    local is = inlist("`stat'","change","first","dydx","estimat","estimate")
    if `is'==1 {
        local stat "change"
        local isbad = 0
    }
    local is = inlist("`stat'","dc","e","es","est","esti","estim","estima")
    if `is'==1 {
        local stat "change"
        local isbad = 0
    }
    local is = inlist("`stat'","upper","ub")
    if `is'==1 {
        local stat "ul"
        local isbad = 0
    }
    local is = inlist("`stat'","lower","lb")
    if `is'==1 {
        local stat "ll"
        local isbad = 0
    }
    local is = inlist("`stat'","p","pv","pva","pval","pvalu","pvalue")
    if `is'==1 {
        local stat "pvalue"
        local isbad = 0
    }
    sreturn local stat "`stat'"
    sreturn local isbad "`isbad'"

end
exit
* 0.6.0 2012-09-30 | long freese | _rm_modelinfo with r() not s()
* 0.6.1 2012-10-01 | long freese | skips i.cat or int
* 0.6.2 | long freese | quadratics work
* 0.6.3 | long freese | i.catvar works - to clean later
* 0.6.4 | long freese | i.catvar output and factor
* 0.6.5 | long freese | varlist i.bin error trapped
* 0.6.6 | long freese | minor; mchange 2.catvar error; see `mainvars'
*       remove matrixsave()
* 0.6.8 | long freese | #: not #.
* 0.6.7 | long freese | respond to JF's ideas
* 0.7.2 | long freese | _mchange_plot_pvalue
* 0.7.1 | long freese | gologit2; std() refinements
* 0.7.0 | long freese | std() and _mchange_std
* 0.8.2 2013-02-01 | long freese | preserve
* 0.8.1 2013-01-31 | long freese | use predict for ame
* 0.8.0 2013-01-31 | long freese | error in AME for one and sd; syntax traps
* 0.7.3 2013-01-24 | long freese | remove _dcdp_ add defaultbin;
* 0.7.3 defaultcon; changesingle; changetypes(all)
