*! version 0.3.5 2012-09-05 jsl | names | posted
* version 0.3.4 2012-09-04 jsl | error return | posted
* version 0.3.3 2012-09-02 jsl | bugs add* | posted
    * title
    * atleft and atright; default is atleft option dropped
    * bug with blank fixed
    * wide replace by addright addleft
    * long replace by addabove addbelow
    * cleaned code

* 2. Use tempnames for matrices
* 3. Allow different names for gen items
* 4. allow passthrough of other options to mlist1

capture program drop mstore2
program define mstore2, sclass

    version 11.2

    syntax [anything(name=outputMAT)] , [ ///
///
/// what to save
///
        at    ATVars(string)    /// Save columsn with these names
        TABle TABStats(string)  /// Save cols: b se z p ll ul df crit eform
        STATistics(string) STATS(string) /// select statstics
        NOOMITted               /// Drop omitted columns in at: o. 1b. etc.
    NOCOLMissing NOROWMissing /// Drop if all missing
        rows(numlist)           /// Save rows specified by numlist
        mv(string)              /// Missing value used for missing (. a b ...)
        blank                   /// Add a blank row
    /// How to name what is saved
        colstub(string)         /// Add stub to col names
        COLEQnm(string)         /// Add col eq name to columns
        /// OUTcome(string) /// Add this number to column names
        CNUMber CNUMBEROnly     /// Name columns with numbers
        rowstub(string)         /// Add stub to row names
        ROWEQnm(string)         /// Add row eq name to rows
        RNUMber RNUMBEROnly     /// Use row # for row names
    /// Where to save it the information
        GENerate(string)        /// Generate variables from saved columns
        GENStub(string)         ///   Stub in front of variable names
        MOUTcome(string) /// Add # to matrix name for margins outcome()
        save(string)            /// Save matrix also with this name
    /// How create the matrix
        clear                   /// Reset matrix to null before creating
        ATRIGHT /// Place at matrix at right/left of table mat
        ADDAbove ADDBelow ADDRight ADDLeft /// where added matrix goes
    /// How list it
        list                    /// List matrix
names(string) /// passed to matlist all by default
        title(string)           /// Title when listing
        preview                 /// Preview changes but don't change matrix
        Format(string)          /// format when listing matrix
        WIDth(numlist >0 integer) /// Column width when listing matrix
        DECimals(numlist >-1 integer) /// Digits when list matrix
    ]

    local error = 0

    tempname margins_mstore
    capture _return drop `margins_mstore'
    _return hold         `margins_mstore'
    _return restore      `margins_mstore', hold

//  decode and test syntax

    local isall = regexm(" `names'","[ ](a|al|all)")
    local isrow = regexm(" `names'","[ ](r|ro|row|rows)")
    local isnon = regexm(" `names'","[ ](n|no|non|none)")
    local iscol = regexm(" `names'","[ ](c|co|col|colu|column|columns)")
    if "`names'"=="" | `isall' {
        local names "all"
    }
    else if `isrow' {
        local names "rows"
    }
    else if `iscol' {
        local names "columns"
    }
    else if `isnon' {
        local names "none"
    }
    else {
        display as error ///
        "invalid names() option"
    }

    local nadd = 0
    foreach nm in addbelow addabove addright addleft {
        if ("``nm''"=="`nm'") local ++nadd
    }
    if `nadd'>1 {
        display as error ///
        "only one of addbelow, addabove, addright and addleft can be used" ///
        "at a time"
        exit
    }
    if (`nadd'==0) local addright "addright"

    if ("`statistics'"=="") local statistics `"`stats'"'
    if ("`statistisc'"!="" & "`tabstats'"=="") local tabstats `"`statistics'"'

    * due to complex row names, don't add numbers to them for now....
    if "`rnumber'"=="rnumber" {
        local rnumber ""
        local rnumberonly "rnumberonly"
    }

*    if ("`outcome'"=="") local stubout ""
*    else {
*        capture confirm integer number `outcome'
*        if _rc>0 {
*            di as error "outcome() must be an integer."
*            local error = 1
*        }
*        local stubout = `outcome'
*    }

    if ("`moutcome'"=="") local mstubout ""
    else {
        capture confirm integer number `moutcome'
        if _rc>0 {
            di as error "moutcome() must be an integer."
            local error = 1
        }
        if (`moutcome'>=0) local mstubout "`moutcome'"
        if `moutcome'<0 {
            local mstubout = abs(`moutcome')
            local mstubout "_`mstubout'"
        }
    }
    if "`outputMAT'"=="" local outputMAT _mstore`mstubout'
    else local outputMAT `outputMAT'`mstubout'

    if "`clear'"=="clear" {
        capture matrix drop `outputMAT'
    }

    if "`at'"=="" & "`table'"=="" local table "table" // table is default

    if "`atvars'"=="_none" {
        local at ""
        local atvars ""
    }

    if "`atvars'"!="" local at "at"
    if "`tablestats'"!="" local table "table"

    local atvars : list uniq atvars
    local tabstats : list uniq tabstats

    local getAT = 0
    local getTBL = 0
    if "`at'"=="at" local getAT = 1
    if "`tabstats'"=="_none" local table ""
    if "`table'"=="table" local getTBL = 1

    if `error' {
         _return restore `margins_mstore'
         capture _return drop `margins_mstore'
         exit
    }

//  check if matrices exit

    local existsAT = 0
    local existsTBL = 0

    qui capture confirm matrix r(at)
    if !_rc {
        local  existsAT = 1
        matrix matrixAT = r(at)
        local varnmsAT : colnames matrixAT
    }

    qui capture confirm matrix r(table)
    if !_rc {
        local  existsTBL = 1
        matrix matrixTBL = r(table)' // transpose so cols are stats
    }

    if `existsAT'==0 & `getAT' {
        di as error "r(at) is not in memory and you used option at"
        local error = 1
    }
    if `existsTBL'==0 & `getTBL' {
        di as error "r(table) is not in memory and you used option table"
        local error = 1
    }

   if `error' {
         _return restore `margins_mstore'
         capture _return drop `margins_mstore'
         sreturn local error = 1
         exit
   }

//  drop omitted and get matrix info

    foreach type in AT TBL {

        if "`noomitted'"=="noomitted" {
            tempname omitmat

            * omitted from columns
            local ncols = colsof(matrix`type')
            _ms_omit_info matrix`type' // find omitted names
            if r(k_omit)>0 {
                matrix `omitmat' = J(1,`ncols',1) - r(omit)
                _rm_matrix_select matrix`type' `omitmat' col
            }

            * omitted from rows
            matrix matrix`type' = matrix`type'' // transposed
            local ncols = colsof(matrix`type')
            _ms_omit_info matrix`type' // find omitted names
            if r(k_omit)>0 {
                matrix `omitmat' = J(1,`ncols',1) - r(omit)
                _rm_matrix_select matrix`type' `omitmat' col
            }
            matrix matrix`type' = matrix`type''

        }

        local  rownms`type' : rownames matrix`type'
        local  colnms`type' : colnames matrix`type'
        local  nrows`type' = rowsof(matrix`type')
        local  ncols`type' = colsof(matrix`type')
        matrix colnumsel`type' = J(1,`ncols`type'',1)
        * TBL is created last as the default
        local  rownms `"`rownms`type''"'
        local  nrows = `nrows`type''
        local  ncols = `ncols`type''

    } // type

//  decode columns selection

    if `getAT' {

        if "`atvars'"=="" {
            capture matrix drop colindexAT
            numlist "1(1)`ncolsAT'", integer min(1)
            matrix colnumselAT = J(1,`ncolsAT',1)
            local  colselnmsAT "`colnmsAT'"
            forvalues i = 1(1)`ncolsAT' {
                matrix colindexAT = nullmat(colindexAT) , `i'
            }
            local lblnamesAT "`colnmsAT'"
            local srcnamesAT "`colnmsAT'"
        }
        if "`atvars'"!="" {

            * c. isn't needed and causes error; automatically remove it
            local newatvars ""
            foreach iatnm of local atvars {
                local iatnm : subinstr local iatnm "c." "", all
                local newatvars `"`newatvars'`iatnm' "'
            }
            local atvars `"`newatvars'"'

            * are atvars valid?
            foreach iatnm of local atvars {
                local ipos : list posof "`iatnm'" in varnmsAT
                if `ipos' == 0 {
                    di as error ///
`"atvar() name "`iatnm'" is not in r(at). If atvar is a factor variable,"'
                    di as error ///
`"use correct prefix, such as "1.wc", not "wc" or "i.wc""'
                    local error = 1
                    continue, break
                }
            }
            if `error' {
                _return restore `margins_mstore'
                capture _return drop `margins_mstore'
                sreturn local error = 1
                exit
            }

            _rm_parse_AeqB, list(`atvars') // all names ok
            local lblnamesAT "`s(label_names)'"
            local srcnamesAT "`s(source_names)'"

            _rm_matrix_rclist, rclist(`srcnamesAT') rclabels(`lblnamesAT') ///
                rcnames(`colnmsAT') unab

            matrix colnumselAT = r(selectmat)
            matrix colindexAT = r(indexmat) // in order of atvars()
            local lblnamesAT "`r(newnames)'" // names after selection
        }
    }

    if `getTBL' {

        if "`tabstats'"=="" {
            local  colnumsel "1 2 3 4 5 6" // skip 7 8 9
            matrix colnumselTBL = J(1,`ncolsTBL',0) //
            foreach icol in `colnumsel' {
                matrix colnumselTBL[1,`icol'] = 1
                local  stat : word `icol' of `colnmsTBL'
                local  colselnmsTBL "`colselnmsTBL' `stat'"
            }
        }
        else if "`tabstats'"=="_none" {
            * for now do nothing here
        }
        else {

            * use only those in r(table)
            local stats_valid "b se z pvalue ll ul df crit eform" // stata names

            _rm_parse_AeqB, list(`tabstats')  sourcenames(`stats_valid')
            local lblnamesTBL "`s(label_names)'"
            local srcnamesTBL "`s(source_names)'"

            * returns with names used for statistics (used by mgen)
            foreach stat in b se z pvalue ll ul df crit eform {
                local `stat'_nm "`stat'"
            }
            local i = 0
            foreach stat in `srcnamesTBL' {
                local ++i
                local lbl : word `i' of `lblnamesTBL'
                local `stat'_nm "`lbl'"
            }

            _rm_matrix_rclist, rclist(`srcnamesTBL') rclabels(`lblnamesTBL') ///
                rcnames(`colnmsTBL')
            matrix colnumselTBL = r(selectmat)
            local lblnamesTBL "`r(newnames)'"
            matrix colindexTBL= r(indexmat) // in order of tabstats()

        }

    } // decode TBL columns

//  decode rows

    local rowselnms ""
    if "`rows'"=="" {
        matrix rowselectMAT = J(1,`nrows',1)
        local rowselnms "`rownms'"
    }
    else {
        numlist "`rows'", integer min(1) range(>0 <=`nrows')
        local rowselect "`r(numlist)'"
        local rowselect : list uniq rowselect
        matrix rowselectMAT = J(1,`nrows',0) //
        foreach irow in `rowselect' {
            matrix rowselectMAT[1,`irow'] = 1
            local  rnm : word `irow' of `rownms'
            local  rowselnms "`rowselnms' `rnm'"
        }
    }

//  check input and output matrices

    capture confirm matrix `outputMAT'
    local existsOUT = 0
    if !_rc {
        local existsOUT = 1
        local rownmsOUT : rownames `outputMAT'
        local colnmsOUT : colnames `outputMAT'
        local rownms "`rownmsOUT'"
        local nrowsOUT = rowsof(`outputMAT')
        local ncolsOUT = colsof(`outputMAT')
    }
    else {
        local nrowsOUT = 0
        local ncolsOUT = 0
    }

//  select input rows and columns; remove missing

    foreach type in AT TBL {

        if `get`type'' {

            * colnumsel`type' is col selection vector
            * colindex`type'  is vector of indexes to keep
            * matrix`type'    is the source matrix
            * rowselectMAT    is the row select vector
            * lblnames`type'  is the labels for selected columns
            * srcnames`type'  is the source names for columns

            _rm_matrix_index matrix`type' colindex`type' col
            matrix colnames matrix`type' = `lblnames`type''

            * DO: verify that ordering is not an issue here
            _rm_matrix_select matrix`type' rowselectMAT row  // "`lblnames`type''"

            * find rows/cols with all missing
            mata: inmat = st_matrix("matrix`type'")
            mata: colnomiss = (colsum(inmat :==.):!=rows(inmat))
            mata: rownomiss = (rowsum(inmat :==.):!=cols(inmat))
            mata: st_matrix("colnomiss",colnomiss)
            mata: st_matrix("rownomiss",rownomiss)

            if "`nocolmissing'"=="nocolmissing" {
                _rm_matrix_select matrix`type' colnomiss col
            }
            if "`norowmissing'"=="norowmissing" {
                * nothing for now
            }

        } // get type of matrix

        local  nrows`type' = rowsof(matrix`type')
        local  ncols`type' = colsof(matrix`type')

    } //type loop

    if `getAT' & `getTBL' & `nrowsAT'!=`nrowsTBL' {
        di as error ///
        "r(at) and r(table) have incompatable dimensions"
        local error = 1
    }

//  row labels are determined here not in mlist to make sure when you
//  stack matrices you can have different labels

    if "`rnumber'"=="rnumber" & "`rnumberonly'"=="rnumberonly" {
        di as error ///
        "rnumber and rnumberonly cannot be used together"
        local error = 1
    }
    if "`cnumber'"=="cnumber" & "`cnumberonly'"=="cnumberonly" {
        di as error ///
        "cnumber and cnumberonly cannot be used together"
        local error = 1
    }

    if `error' {
        _return restore `margins_mstore'
        capture _return drop `margins_mstore'
        exit
    }

    * add numbers to current names
    foreach type in AT TBL {

        foreach rowcol in row col {

            local rc "r"
            if "`rowcol'"=="col" local rc "c"

            * add numbers
            if "``rc'number'"=="`rc'number" {

                local newnames ""
                local oldnames : `rowcol'names matrix`type'
                local stub ""
                if "`stub'"!="" local stub "``rowcol'stub'_"

                local i = 0
                foreach nm in `oldnames' {
                    local ++i
                    local newnames "`newnames' `""`stub'`i'`nm'""'"
                }

                matrix `rowcol'names matrix`type' = `newnames'

            } // add #

            * #only w/wo stub
            else if "``rc'numberonly'"=="`rc'numberonly" {

                local newnames ""
                local oldnames : `rowcol'names matrix`type'
                local stub ""
                if "``rowcol'stub'"!="" local stub "``rowcol'stub'_"

                local i = 0
                foreach nm in `oldnames' {
                    local ++i
                    local newnames "`newnames' `""`stub'`i'""'"
                }

                matrix `rowcol'names matrix`type' = `newnames'

            } // #only + stub

            * no numbering : null stub added if not stub
            else {

                local newnames ""
                local oldnames : `rowcol'names matrix`type'
                local stub "``rowcol'stub'"

                local i = 0
                foreach nm in `oldnames' {
                    local ++i
                    local newnames "`newnames' `""`stub'`nm'""'"
                }

                matrix `rowcol'names matrix`type' = `newnames'

            } // no #ing

        } // row col

    } // AT or TBL

//  update matrix

    //  get current matrix

    if `getAT' & `getTBL' {
        if "`atright'"=="atright" {
            matrix tosaveMAT = matrixTBL, matrixAT
        }
        else {
            matrix tosaveMAT = matrixAT, matrixTBL
        }
    }
    else if `getAT' {
        matrix tosaveMAT = matrixAT
    }
    else if `getTBL' {
        matrix tosaveMAT = matrixTBL
    }
    local nrowstosave = rowsof(tosaveMAT)
    local ncolstosave = colsof(tosaveMAT)

    if "`roweqnm'"!="" {
         matrix roweq tosaveMAT = `roweqnm'
    }
    if "`coleqnm'"!="" {
         matrix coleq tosaveMAT = `coleqnm'
    }

    //  combine new matrix with existing matrix

    if `existsOUT' {

        local nrowsout = rowsof(`outputMAT')
        local ncolsout = colsof(`outputMAT')

        if "`addright'"=="addright" | "`addleft'"=="addleft" {
            if `nrowstosave'!=`nrowsout' {
                di as error "new matrix has `nrowstosave' rows, but" ///
                " `outputMAT' has `nrowsout' rows"
                 _return restore `margins_mstore'
                 capture _return drop `margins_mstore'
                 exit
            }
        }
        if "`addabove'"=="addabove" | "`addbelow'"=="addbelow" {
            if `ncolstosave'!=`ncolsout' {
                di as error "new matrix has `ncolstosave' columns, but" ///
                " `outputMAT' has `ncolsout' columns"
                 _return restore `margins_mstore'
                 capture _return drop `margins_mstore'
                 exit
            }
        }
        if "`addright'"=="addright" {
            matrix `outputMAT' = `outputMAT', tosaveMAT
        }
        if "`addleft'"=="addleft" {
            matrix `outputMAT' = tosaveMAT, `outputMAT'
        }
        if "`addabove'"=="addabove" {
            matrix `outputMAT' = tosaveMAT \ `outputMAT'
        }
        if "`addbelow'"=="addbelow" {
            matrix `outputMAT' = `outputMAT' \ tosaveMAT
        }

    }
    else { // outputMAT does not exist

        matrix `outputMAT' = tosaveMAT
    }

//  list

    if "`list'"!="" | "`generate'"!="" | "`genstub'"!="" {

        if ("`title'"=="") local title "Created by mstore"

        if ("`list'"=="list") local nolist ""
        if ("`list'"=="") local nolist "nolist"

        * to not use mlist for numbering or adding stubs since mstore
        * adds them to each new matrix added to existing matrix
        * mlist does it to the entire matrix it is working on

        mlist1 `outputMAT', names(`names') ///
            `blank' `calpha' `ralpha' ///
            cdrop(`cdrop') rdrop(`rdrop') ckeep(`ckeep') rkeep(`rkeep') ///
            `cnames' `rnames' corder(`corder')  rorder(`rorder') ///
            crename(`crename') rrename(`rrename') ///
            decimals(`decimals') format(`format') ///
            generate(`generate') genstub(`genstub') ///
            mv(`mv') `nolist' `nocoleqnm' `preview' save(`save') ///
            title(`title') `transpose' width(`width') ///
            bnm(`b_nm') senm(`se_nm') znm(`b_nm') pnm(`pvalue_nm') ///
            lbnm(`ll_nm') ubnm(`ul_nm') dfnm(`df_nm') critnm(`crit_nm') ///
            eformnm(`eform_nm')
    }

//  close up

    if "`save'"!="" {
        di "TO ADD: save the matrix"
    }

    _return restore `margins_mstore'
    capture _return drop `margins_mstore'

    sreturn local b `"`b_nm'"'
    sreturn local se `"`se_nm'"'
    sreturn local z `"`b_nm'"'
    sreturn local pvalue `"`pvalue_nm'"'
    sreturn local ll `"`ll_nm'"'
    sreturn local ul `"`ul_nm'"'
    sreturn local df `"`df_nm'"'
    sreturn local crit `"`crit_nm'"'
    sreturn local eform `"`eform_nm'"'

end
exit

DOCUMENTATION
tabstats(_none)
stats and statistics are synonyms for tabstats
changed DROPOMITTED to NOOMITTED
changed DROPCOLM to NOCOLM
changed DROPROWM to NOROWM

HISTORY

* version 0.2.3 2012-08-24 -posted prior to adding mp_matrix_index
    * change DROPOMITTED to NOOMITTED
    * change DROPCOLM to NOCOLM
    * change DROPROWM to NOROWM
* version 0.2.2 2012-08-24 omitted taken care of early in program - posted
* version 0.2.1 2012-08-23 - posted
*   Add row and column stubs; do numbering internally; done
*   Clean up restore;
*   noomit on r(table) rows changed to dropomitted
* 0.2.0 2012-08-22 add a=b to select in mstore1 - posted
* version 0.3.1 2012-08-24 - posted
    * bug in generating index by not clearing a matrix
* version 0.3.0 2012-08-24 -posted
    * use mp_matrix index to maintain naming of selected rows columnns
* version 0.3.2 2012-08-26 jsl | fv fixes | posted
    * use _rm_matrix_rclist
    * use _rm_matrix_index
    * use _rm_parse_AeqB
    * error if atvars() names not in r(at)
    * replace c.x as x in atvars() : will this always work?
    * use stats and statistics as synonym for tabstat

