
*! version 0.0.5 jsl 2012-07-03 12.08 fix up r(at) logic

/* To-do:
1. Test generate() and genstub() options
2. statsto statout passthroughs?
*/

    //  Command : mtable
//  Author  : scott long
//  Content : put margins results in table
//  Requires: collect.pkg

capture program drop mtable1
program define mtable1

    local test = 0

    syntax [anything(name=mytable)] , ///
        [                             ///
        NOList                        /// do not list matrix
        ROWSelect(string asis)        /// select and name rows
        STATistics(string asis)       /// select statstics
        STATS(string asis)            /// synonym for statistics
///
        atoff NOATvars                /// Do not add at() matrix
        ATvars(string asis)           /// select and rename r(at) variables
        ATLABels                      /// use atvars to values to label rows
///
        COLEQstub(string asis)        /// eq labels for col and row
        ROWEQstub(string asis)        ///
///
        GENerate(string asis)         /// create variables from columns
        genstub(string asis)          /// Generate columns with stub
///
        CORDer(string asis)           /// reorder & select columns
        RORDer(string asis)           /// reorder & select row
///
        clear                         /// reset matrix to null
        DECimals(numlist >-1 integer) /// digits when list matrix
        width(numlist >5 integer)     /// column widths
        title(string)                 /// title added when listing
        RNUMber                       /// number rows
        ]



    if ("`statistics'"=="") local statistics `"Margin=b LB=lb UB=ub"'

    * if only reorder, do not change matrix
    if `"`rowselect'"'=="" & `"`statistics'"'=="" & `"`atvars'"'==""   & ///
       `"`atoff'"'==""     & `"`nolist'"'==""     & `"`decimals'"'=="" & ///
       `"`clear'"'==""     & `"`generate'"'==""   & `"`atlabels'"'==""  & ///
       `"`genstub'"'==""   & (`"`rorder'"'!="" | `"`corder'"'!="") {
        local changematrix = 0
    }
    else local changematrix = 1



//  decide on how to treat at variables

    capture confirm matrix r(at)
    local no_atreturn = _rc // 0 if r(at) is in memory
    if `no_atreturn'>0 & ("`atvars'"!="" | "`atlabels'"!="") {
        di as text "Warning: r(at) is not in memory"
        local atoff "atoff"
    }

    if ("`atoff'"=="atoff") {
        local atvars ""
        local atlabels ""
    }

*? if atlabels, use the atvars
    if "`atlabels'"=="atlabels" {
        local atlabels "`atvars'"
        local atvars ""
    }

    //  collect info from from r(b) and r(at)

    if `changematrix' {

        if `test' {
            di "statsto `mytable', atlabels(`atlabels') atreturns(`atvars') coleq(`coleqstub') rbreturns(`statistics') roweq(`roweqstub') rowselect(`rowselect') "
        }

        statsto `mytable', ///
            atlabel(`atlabels') atreturns(`atvars') ///
            rowselect(`rowselect') rbreturns(`statistics') ///
            coleq(`coleqstub') roweq(`roweqstub') ///
            `clear'
    }

    //  generate variables from columns of matrix

    if `changematrix' & (`"`generate'"'!="" | `"`genstub'"'!="") {
        statout `mytable', generate(`generate') genstub(`genstub')
    }

    //  list results

        if `test' {
            di "statout `mytable', `list' title(`title') dec(`decimals') rorder(`rorder') corder(`corder') nocount"
        }

    * add row numbers
    if "`rnumber'"=="rnumber" {
        local rowN = rowsof(`mytable')
        local rnames ""
        forvalues i = 1(1)`rowN' {
            local rnames "`rnames' R`i'"
        }
        matrix rownames `mytable' = `rnames'
    }

    statout `mytable', ///
        corder(`corder') rorder(`rorder') ///
        title(`title') dec(`decimals') `widthis' ///
        `list' nocount

end
exit

NOTES

* version 0.0.4 jsl 2012-06-18 cleanup; new options
* version 0.0.3 jsl 2012-06-18 warning if no at in memory
* version 0.0.2 jsl 2012-06-18 12.30
* version 0.0.1 jsl 2012-06-18
