*! version 0.4.0 2012-09-04 jsl | dcp ocp work | NOT posted

program define orp

*! version 0.4.1 2012-09-04 jsl | dcp ocp work | NOT posted

    version 11.2

    syntax [varlist(default=none)], [ /// O = orplot  D = dcplot
///
/// first part is same as _ordcplot_syntax
///
/// axis and graph region
    max(real 99999) /// OD max of x axis
    min(real -99999) /// OD min of x axis
    gap(real 0) /// OD gap between tick marks
    NTics(integer 5) /// OD # of tics on axis; or use gap()
    XLINEs(string) /// OD xline options (size color everything)
///
/// plot region and labeling
    ASPECTratio(real 0) /// OD aspect ratio for graph
    DECimals(integer 2) /// OD dec digits on axis labels
    ORDECimals(integer 2) /// O  dec digits for the OR scale
///
/// symbols for outcome categories
    BASEcategory(integer -1) /// O  base category for OR plot
    DChange /// O  add DC to or plot
    MColors(string) /// OD color of markers
    MSIZefactor(string) /// OD size of markers; factor only
    nosign /// O  do not underline negative DC's in orplot
    std(string) /// OD Binary Unstd Sstd Rrange  b u s r
    VALues /// OD plot values not letters of value labels
///
/// connecting list
    LINEPvalue(string) /// LINEPvalue(real .1) /// O  line if < less sig
    LColors(string) /// O  colors for connecting lines
    LINEGAPfactor(real 1) /// O  factor change gap around symbols for lines
    LWidths(string) /// O  width of connecting lines
    PACKed /// O  no offset of markers
    OFFSETLIST(string) /// list of 1 per category per variable ranging from 5 to -5
///
/// labels and notes
    CAPtion(string) /// OD text for provenance
    Note(string) /// OD text with options for graph note() option
    PROVenance(string) /// caption with formatting (No OPTprovenance)
    SUBtitle(string) /// OD text with options for subtitle() option
    TItle(string) /// OD text with options for graph title() option
    VARLabels /// OD use variable labels to label variables
///
/// adjusting defaults
    GRAPHoptions(string) /// OD pass through options to plot commands; TO TEST
    OFFSETFactor(real 1) /// O  multiply vertical offsets in OR plot by this
    OFFSETSEQuence(string) /// O  0 1 2 is default for vertical offsets
    STDLABELSPaces(integer 0) /// OD # spaces at end of coef type label; can be <0
///
/// utility and to be added
    debug(integer 0) /// OD
    matrix /// OD enter data as matrices not estimation
///
/// second part is to turn off options that are words
/// if arguments, enter new ones
///
/// plot region and labeling
    NOASPECTratio ///
    NODECimals ///
    NOORDECimals ///
///
/// symbols for outcome categories
    NOBASEcategory ///
    NODChange ///
    NOMColors ///
    NOMSIZefactor ///
    NOnosign ///
    NOstd ///
    NOVALues ///
///
/// connecting list
    NOLINEPvalue ///
    NOLColors ///
    NOLINEGAPfactor ///
    NOLWidths ///
    NOPACKed ///
    NOOFFSETLIST ///
///
/// labels and notes
    NOCAPtion ///
    NONote ///
    NOPROVenance ///
    NOSUBtitle ///
    NOTItle ///
    NOVARLabels ///
///
/// adjusting defaults
    NOGRAPHoptions ///
    NOOFFSETFactor ///
    NOOFFSETSEQuence ///
    NOSTDLABELSPaces ///
    ]

//  options to check

    #delimit ;
    * options using ()'s ;
    local optparlist "
        aspectratio
        basecategory
        caption
        debug
        decimals
        gap
        graphoptions
        lcolors
        linegapfactor
        linepvalue
        lwidths
        max
        mcolors
        min
        msizefactor
        note
        ntics
        offsetfactor
        offsetlist
        offsetsequence
        ordecimals
        provenance
        std
        stdlabelspaces
        subtitle
        title
        xlines
    ";

    * options using as only words ;
    local optparword "
        dchange
        matrix
        nosign
        packed
        values
        varlabels
    ";
    #delimit cr

//  create new command

    local newvarlist "`_orp[plt_rhsNMS]'"
    if "`varlist'"!="" local newvarlist "`varlist'"

    local newcmd `"`newvarlist', "'

    * options that are words only
    foreach opt in `optparword' {

        * NOoption specified to remove current option
        local isno = 0
        if ("`no`opt''"=="no`opt'") local isno = 1

        * option from current plot
        local curopt "`_orp[`opt']'"

        * options is currently _none_
        local isnone = 0
        if ("`curopt'"=="_none_") local isnone = 1

        if `isno'==1 {
            char _orp[`opt'] "_none_"
            local newopt ""
        }
        * get new option
        else if `"``opt''"'!="" {
            local newopt "`opt'"
        }
        else {
            local newopt ""
        }
        local newcmd `"`newcmd' `newopt'"'
    }

    * options with parameters
    foreach opt in `optparlist' {

        * NOoption specified to remove current option
        local isno = 0
        if ("`no`opt''"=="no`opt'") local isno = 1

        * option from current plot
        local curopt "`_orp[`opt']'"

        * options is currently _none_
        local isnone = 0
        if ("`curopt'"=="_none_") local isnone = 1

        if `isno'==1 {
            char _orp[`opt'] "_none_"
            local newopt ""
        }
        * get new option
        else if `"``opt''"'!="" {
            local newopt "`opt'(``opt'')"
        }
        else {
            local newopt ""
        }
        local newcmd `"`newcmd' `newopt'"'
    }

//  send to _ordc_plot_syntax

    _ordcplot_syntax `newcmd'

end

exit

VERSIONS

NOTES
