.-
help for ^fitstat^ - 03Nov2005
.-

To document: ztp and ztnb
           : option nostata to supress bic aic based on stata formula

Compute fit statistics for single equation regression models.
-------------------------------------------------------------

    ^fitstat^ [^, s^aving^(name)^ ^u^sing^(name)^ ^b^ic ^force^ ^save^ ^diff^]

Description
-----------

^fitstat^ is a post-estimation command that computes a variety of measures
of fit for many kinds of regression models.  It works after the following:
^clogit^, ^cnreg^, ^cloglog^, ^intreg^, ^logistic^, ^logit^, ^mlogit^, ^nbreg^, ^ocratio^,
^ologit^, ^oprobit^, ^poisson^, ^probit^, ^regress^, ^zinb^, and ^zip^.  With the ^s^aving^()^
and ^u^sing^()^ options, it can also be used to compare fit measures for two
different models.

For all models, ^fitstat^ reports the log-likelihoods of the full and
intercept-only models, the deviance (D), the likelihood ratio chi-square
(G2), Akaike's Information Criterion (AIC), AIC*N, the Bayesian Information
Criterion (BIC), and BIC'.

For all models except ^regress^, ^fitstat^ reports McFadden's R2, McFadden's
adjusted R2, the maximum likelihood R2, and Cragg & Uhler's R2.  These
measures all equal R2 for OLS regression.  ^fitstat^ reports R2 and the
adjusted R2 after ^regress^.

fitstat reports the regular and adjusted count R2 for categorical data models.
For ordered or binary logit or probit models, as well as models for censored
data (^tobit^, ^cnreg^, or ^intreg^), it also reports McKelvey and Zavonia's R2.
In addition, it reports Efron's R2 for ^logit^ or ^probit^.

Not all measures are provided for models estimated with ^pweight^s or ^iweight^s.

Options
-------

^saving(^name^)^ saves the computed measures in a matrix for subsequent
    comparisons.  Name cannot be longer than 4 characters.

^using(^name^)^ compares the fit measures for the current model with those of
    the model saved as name.  Name cannot be longer than 4 characters.

^bic^ only presents information measures.

^force^ will compare two models even when the number of observations or the
    estimation method varies between the two models.

^save^ and ^diff^ are equivalents of saving(0) and using(0) and do not require
    the user to provide model names.

Examples
--------

To compute fit statistics for a single model:

 . ^use mroz,clear^
 . ^logit lfp k5 k618 age wc hc lwg inc^
 . ^fitstat^

To compute and save fit measures:

 . ^logit lfp k5 k618 age wc hc lwg inc^
 . ^fitstat, saving(mod1)^

To compare saved model to current model:

 . ^logit lfp k5 k618 age age2 wc hc lwg inc^
 . ^fitstat, using(mod1)^

.-
Authors: J. Scott Long and Jeremy Freese
         www.indiana.edu/~jslsoc/spost.htm
         spostsup@@indiana.edu
