
*! version 3.0.4 scott long zi with factors

//  return names and number of rhs variables; handles factor variables
* should be replace by _rm_modelinfo.ado

capture program drop rm3_perhs
program define rm3_perhs, rclass // determine rhs variables
    version 8
    syntax [namelist(name=beta)] [,NOomit]

    if "`beta'" == "" {
        tempname beta
        matrix `beta' = e(b)
    }

    local iszi = 0 // is zip or zinb
    if ("`e(cmd)'"=="zip" | "`e(cmd)'"=="zinb") local iszi = 1

    _ms_omit_info `beta'
    local Nomitted = `r(k_omit)' // # omitted
    local NMSb : colnames `beta'
    local NMSb : subinstr local NMSb "o._cons" "", all // remove 0._cons
    local NMSb : subinstr local NMSb "_cons" "", all
    local Neq1 0
    local Neq2 0
    local eqstart = 1
    local eqend = 1 + cond(`iszi'==1,1,0)

    if "`e(cmd)'"=="mlogit" | "`e(cmd)'"=="mprobit"{
        if "`e(cmd)'"=="mlogit"  local ibase = e(ibaseout)
        if "`e(cmd)'"=="mprobit" local ibase = e(i_base)
        if `ibase'==1 { // can't get names from base equation
            local eqstart = 2
            local eqend = 2
        }
    }
    forvalues ieq = `eqstart'/`eqend' {
        _ms_extract_varlist `NMSb', noomit eq(#`ieq') nofatal
        local NMSnoomit "`NMSnoomit' `r(varlist)'"
        _ms_extract_varlist `NMSb', eq(#`ieq') nofatal
        local NMSall "`NMSall' `r(varlist)'"

        if `ieq'==1 | (`ieq'!=1 & `iszi'==0) { 
            local NMSeq1 `NMSnoomit' 
            local Neq1 : word count `NMSeq1'
        }
        else {
            local Nend : word count `NMSnoomit' // has all non ommited names
            local Nstart = `Neq1' + 1
            forvalues i = `Nstart'(1)`Nend' {
                local inm : word `i' of `NMSnoomit'
                local NMSeq2 "`NMSeq2' `inm'"
            }
            local Neq2 : word count `NMSeq2'
        }
    }

    // strip off _cons, _cut & _se
    tokenize "`NMSeq1'", parse(" ")
    local rhsnm ""
    local hascon "no"
    local i 1
    while "``i''" != "" {
        if ("`i'"=="1") local nm1 "``i''"
        else if ("`nm1'"=="``i''") local hascon "yes"
        if "``i''" == "_cons" & "`hascon'"=="no" {
            local hascon "yes"
            local start2 = `i' + 1
        }
        if "``i''" != "_cons" & "``i''" != "_se" ///
            & substr("``i''",1,4) != "_cut" & "`hascon'"=="no" {
            local rhsnm "`rhsnm' ``i''"
        }
        local ++i
    }
    local NMSeq1 "`rhsnm'"
    local Neq1 : word count `rhsnm'

    if `iszi'==1 { // zi has 2nd equation to process
        tokenize "`NMSeq2'", parse(" ")
        local rhsnm ""
        local hascon "no"
        local i 1
        while "``i''" != "" {
            if ("`i'"=="1") local nm1 "``i''"
            else if ("`nm1'"=="``i''") local hascon "yes"
            if "``i''" == "_cons" & "`hascon'"=="no" {
                local hascon "yes"
                local start2 = `i' + 1
            }
            if "``i''" != "_cons" & "``i''" != "_se" ///
                & substr("``i''",1,4) != "_cut" & "`hascon'"=="no" {
                local rhsnm "`rhsnm' ``i''"
            }
            local ++i
        }
        local NMSeq2 "`rhsnm'"
        local Neq2 : word count `rhsnm'
    } 

    return local rhsnms   "`NMSeq1'"
    return local nrhs     "`Neq1'"
    return local rhsnms2  "`NMSeq2'"
    return local nrhs2    "`Neq2'"
end
exit

HISTORY

* version 3.0.3 2012-07-26 returns when i.white
* version 3.0.2 2012-07-25 mlogit fix if excluded category
* version 3.0.1 2012-06-02 mlogit fix
* version 3.0.0 2012-06-02
* version 2.0.0 07jul2009 factor variables allowed
* version 1.6.5 13Apr2005
* version 1.6.4 2005-01-23 fix with zip and nocon

